=== nptl/sysdeps/unix/sysv/linux/alpha/Makefile ===
# pull in __syscall_error routine, __sigprocmask, __syscall_rt_sigaction
libpthread-routines += ptw-sysdep ptw-sigprocmask ptw-rt_sigaction
